#include "io430.h"
#include <stdbool.h>
#include <stdio.h>

#define maximumNumberOfElements 8
void enqueue(int x);
bool hasNext(void);
int dequeue(void);

int main(void)
{
  enqueue(13);
  enqueue(42);
  if(hasNext())
  {
    printf("%d\n", dequeue());
  }
  if(hasNext())
  {
    printf("%d\n", dequeue());
  }
  if(hasNext())
  {
    printf("%d\n", dequeue());
  } 
  enqueue(11);
  enqueue(12);
  enqueue(13);
  enqueue(14);
  enqueue(15);
  enqueue(16);
  enqueue(17);
  enqueue(18);  
  enqueue(19);  
  while(hasNext())
  {
    printf("%d\n", dequeue());
  } 
  
  return 0;
}

// effiziente Lsung mit Ringpuffer = Circular Buffer

int queue[maximumNumberOfElements];
int count = 0;
int first = 0;

void enqueue(int x)
{
  if(count < maximumNumberOfElements)
  {
    int position = first - count;
    if(position < 0)
    {
      position += maximumNumberOfElements;
    }
    queue[position] = x;
    count++;
  }
}

bool hasNext(void)
{
  return count > 0;
}

int dequeue(void)
{
  int x = queue[first];
  count--;
  first--;
  if(first < 0)
  {
    first = maximumNumberOfElements - 1;
  }
  return x;
}